<?php

class ModelShippingSmilePayShippingC2CP extends Model {
	function getQuote($address) {
        // default  cost 60-19999
        
        define("SMILEPAY_SHIPPING_C2CP_MIN_TOTOAL_COST_RANGE",60);
        define("SMILEPAY_SHIPPING_C2CP_MAX_TOTOAL_COST_RANGE",19999);
        // set default range
        $smilePay_shipping_c2cp_min_total_cost =SMILEPAY_SHIPPING_C2CP_MIN_TOTOAL_COST_RANGE;
        $smilePay_shipping_c2cp_max_total_cost = SMILEPAY_SHIPPING_C2CP_MAX_TOTOAL_COST_RANGE;
   
        $product_total_cost = $this->cart->getSubTotal();

		$this->load->language('shipping/smilePay_shipping_c2cp');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('smilePay_shipping_c2cp_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		if (!$this->config->get('smilePay_shipping_c2cp_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

        //if(!isset($this->config->get('smilePay_shipping_c2cp_free_cost')))
         //   $status = false;
       //$this->cart->getTotal();  //include tax
       //$this->cart->getSubTotal()  //  product cost
 
		$total_data = array();
		$total = 0;
		$taxes = $this->cart->getTaxes();

		//get total	
		if (($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) {
		    $sort_order = array();

		    $results = $this->model_extension_extension->getExtensions('total');

		    foreach ($results as $key => $value) {
			    $sort_order[$key] = $this->config->get($value['code'] . '_sort_order');
		    }

		    array_multisort($sort_order, SORT_ASC, $results);

		    foreach ($results as $result) {
			    if ($this->config->get($result['code'] . '_status')) {
				    $this->load->model('total/' . $result['code']);

				    $this->{'model_total_' . $result['code']}->getTotal($total_data, $total, $taxes);
			    }
		    }
					
		}
        $product_total_cost= $total;

        //set free or cost
        if(  $this->config->get('smilePay_shipping_c2cp_free_cost'))
            $product_total_cost > $this->config->get('smilePay_shipping_c2cp_free_cost') ? $ship_cost =0.00 :$ship_cost = $this->config->get('smilePay_shipping_c2cp_cost'); 
        else
            $ship_cost = $this->config->get('smilePay_shipping_c2cp_cost'); 
        //filter total cost between max total cost and min total cost->
        if(!is_null($this->config->get('smilePay_shipping_c2cp_min_total_cost')) && $this->config->get('smilePay_shipping_c2cp_min_total_cost')!="")
            $smilePay_shipping_c2cp_min_total_cost = $this->config->get('smilePay_shipping_c2cp_min_total_cost');
        if(!is_null( $this->config->get('smilePay_shipping_c2cp_max_total_cost')) && $this->config->get('smilePay_shipping_c2cp_max_total_cost')!="")
            $smilePay_shipping_c2cp_max_total_cost = $this->config->get('smilePay_shipping_c2cp_max_total_cost');;
        
        if( $product_total_cost <   $smilePay_shipping_c2cp_min_total_cost || $product_total_cost > $smilePay_shipping_c2cp_max_total_cost)
        {
            $status = false;
        }
        //<-----------------------------

		$method_data = array();


        if(!is_null($this->config->get('smilePay_shipping_c2cp_frontend_title')))
        {
          if(trim($this->config->get('smilePay_shipping_c2cp_frontend_title')) != "" )
             $quote_data_title = $this->config->get('smilePay_shipping_c2cp_frontend_title');
          else
             $this->language->get('text_description');
        } 
        else
          $quote_data_title = $this->language->get('text_description');
          
		if ($status) {
			$quote_data = array();

			$quote_data['smilePay_shipping_c2cp'] = array(
				'code'         => 'smilePay_shipping_c2cp.smilePay_shipping_c2cp',
				'title'        => $this->language->get('text_711_title'),
                'tax_class_id' => 0,
				'cost'         => $ship_cost ,
				'text'         =>$this->currency->format($ship_cost)// $this->currency->format($this->config->get('smilePay_shipping_c2cp_cost'))
			);

			$method_data = array(
				'code'       => 'smilePay_shipping_c2cp',
				'title'      => $quote_data_title,
				'quote'      => $quote_data,
				'sort_order' => $this->config->get('smilePay_shipping_c2cp_sort_order'),
				'error'      => false
			);
		}

		return $method_data;
	}
}