<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
  <div class="page-header">
    <div class="container-fluid">
      <div class="pull-right">
        <button type="submit" form="form-smilepay" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
        <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
      <h1><?php echo $heading_title; ?></h1>
      <ul class="breadcrumb">
        <?php foreach ($breadcrumbs as $breadcrumb) { ?>
        <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
        <?php } ?>
      </ul>
    </div>
  </div>
  <div class="container-fluid">
    <?php if ($error_warning) { ?>
    <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
      <button type="button" class="close" data-dismiss="alert">&times;</button>
    </div>
    <?php } ?>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title"><i class="fa fa-pencil"></i></h3>
      </div>
      <div class="panel-body">
    <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-smilepay">
      <table class="form" >
        <tr height="40">
          <td align="right"><?php echo $entry_status; ?></td>
          <td><select name="smilepay_csv_status">
              <?php if ($smilepay_csv_status) { ?>
              <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
              <option value="0"><?php echo $text_disabled; ?></option>
              <?php } else { ?>
              <option value="1"><?php echo $text_enabled; ?></option>
              <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
              <?php } ?>
            </select></td>
        </tr>
        <tr  height="40" valign="top">
          <td align="right"><span class="required">*</span> <?php echo $entry_dcvc; ?></td>
          <td><input type="text" name="smilepay_csv_dcvc" value="<?php echo isset($smilepay_csv_dcvc) ? $smilepay_csv_dcvc : ''; ?>" size="40" /><br /><?php if (isset($error_warning_dcvc)) { ?><span class="text-danger"><?php echo $error_warning_dcvc; ?></span><?php } ?></td>
        </tr>

        <tr  height="40" valign="top">
          <td align="right"><span class="required">*</span> <?php echo $entry_rvg2c; ?></td>
          <td><input type="text" name="smilepay_csv_rvg2c" value="<?php echo isset($smilepay_csv_rvg2c) ? $smilepay_csv_rvg2c : ''; ?>" size="40" /><br /><?php if (isset($error_warning_rvg2c)) { ?><span class="text-danger"><?php echo $error_warning_rvg2c; ?></span><?php } ?></td>
        </tr>

        <tr  height="40" valign="top">
          <td align="right"><span class="required">*</span> <?php echo $entry_verifykey; ?></td>
          <td><input type="text" name="smilepay_csv_verifykey" value="<?php echo isset($smilepay_csv_verifykey) ? $smilepay_csv_verifykey : ''; ?>" size="40" /><br /><?php if (isset($error_warning_verifykey)) { ?><span class="text-danger"><?php echo $error_warning_verifykey; ?></span><?php } ?><?php echo $entry_verifykey_description; ?></td>
        </tr>         
        <tr  height="40">
          <td align="right" ><?php echo $entry_mid; ?></td>
           <td><select name="smilepay_csv_mid">
              <?php if ($smilepay_csv_mid) { ?>
              <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
              <option value="0"><?php echo $text_disabled; ?></option>
              <?php } else { ?>
              <option value="1"><?php echo $text_enabled; ?></option>
              <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
              <?php } ?>
            </select></td>
        </tr>
        <tr height="40" >
          <td align="right" valign="top"><?php echo $entry_mid_value; ?></td>
          <td><input size="8" type="text" name="smilepay_csv_mid_value" value="<?php echo isset($smilepay_csv_mid_value) ? $smilepay_csv_mid_value : ''; ?>" size="80" /><br /><?php echo $entry_mid_description; ?></td>
        </tr>
        <tr height="40">
          <td align="right" valign="top"><?php echo $entry_limitday; ?></td>
          <td><input size="8" type="text" name="smilepay_csv_limitday" value="<?php echo isset($smilepay_csv_limitday) ? $smilepay_csv_limitday : ''; ?>" size="80" /><br /><?php echo $entry_limitday_description; ?></td>
        </tr>       
        <tr height="40">
          <td align="right"><?php echo $entry_order_status; ?></td>
          <td><select name="smilepay_csv_order_status_id">
              <?php foreach ($order_statuses as $order_status) { ?>
              <?php if ($order_status['order_status_id'] == $smilepay_csv_order_status_id) { ?>
              <option value="<?php echo $order_status['order_status_id']; ?>" selected="selected"><?php echo $order_status['name']; ?></option>
              <?php } else { ?>
              <option value="<?php echo $order_status['order_status_id']; ?>"><?php echo $order_status['name']; ?></option>
              <?php } ?>
              <?php } ?>
            </select></td>
        </tr>
        <tr height="40">
          <td align="right"><?php echo $entry_ordered_status; ?></td>
          <td><select name="smilepay_csv_ordered_status_id">
              <?php foreach ($order_statuses as $order_status) { ?>
              <?php if ($order_status['order_status_id'] == $smilepay_csv_ordered_status_id) { ?>
              <option value="<?php echo $order_status['order_status_id']; ?>" selected="selected"><?php echo $order_status['name']; ?></option>
              <?php } else { ?>
              <option value="<?php echo $order_status['order_status_id']; ?>"><?php echo $order_status['name']; ?></option>
              <?php } ?>
              <?php } ?>
            </select></td>
        </tr>
        <tr height="40" >
              <td align="right"><?php echo $entry_ordered_fail_status; ?></td>
              <td><select name="smilepay_csv_ordered_fail_status_id">
                  <?php foreach ($order_statuses as $order_status) { ?>
                  <?php if ($order_status['order_status_id'] == $smilepay_csv_ordered_fail_status_id) { ?>
                  <option value="<?php echo $order_status['order_status_id']; ?>" selected="selected"><?php echo $order_status['name']; ?></option>
                  <?php } else { ?>
                  <option value="<?php echo $order_status['order_status_id']; ?>"><?php echo $order_status['name']; ?></option>
                  <?php } ?>
                  <?php } ?>
                </select></td>
            </tr>
        <tr height="40">
          <td align="right"><?php echo $entry_geo_zone; ?></td>
          <td><select name="smilepay_csv_geo_zone_id">
              <option value="0"><?php echo $text_all_zones; ?></option>
              <?php foreach ($geo_zones as $geo_zone) { ?>
              <?php if ($geo_zone['geo_zone_id'] == $smilepay_csv_geo_zone_id) { ?>
              <option value="<?php echo $geo_zone['geo_zone_id']; ?>" selected="selected"><?php echo $geo_zone['name']; ?></option>
              <?php } else { ?>
              <option value="<?php echo $geo_zone['geo_zone_id']; ?>"><?php echo $geo_zone['name']; ?></option>
              <?php } ?>
              <?php } ?>
            </select></td>
        </tr>
        
        <tr height="40">
          <td align="right"><?php echo $entry_sort_order; ?></td>
          <td><input type="text" name="smilepay_csv_sort_order" value="<?php echo $smilepay_csv_sort_order; ?>" size="1" /></td>
        </tr>
        <tr height="40" valign="top">
          <td align="right"><?php echo $entry_frontend_title; ?></td>
          <td><input type="text" name="smilepay_csv_frontend_title" value="<?php echo $smilepay_csv_frontend_title; ?>"  size="40" /> </td>
        </tr>        
        <?php 

          foreach ($languages as $language) { 
            if($config_language_id==$language['language_id']) // 抓取當下選取的語言 顯示備註
            {
                   
        ?>
        <tr>
          <td  align="right" width="30%"><?php echo $entry_bank; ?></td>
          <td  height="120"><textarea name="smilepay_csv_description_<?php echo $language['language_id']; ?>" cols="40" rows="5"><?php echo ${'smilepay_csv_description_' . $language['language_id']}; ?></textarea>
            <img src="view/image/flags/<?php echo $language['image']; ?>" title="<?php echo $language['name']; ?>" style="vertical-align: top;" /><br />
            <span><?php echo $entry_bank_note; ?></span>
            </td>
        </tr>
        <?php 
            }
         } ?> 
      </table>
    </form>
      </div>
    </div>
  </div>
</div>
<?php echo $footer; ?> 